searchData={"items":[{"type":"module","title":"Islands.State","doc":"A state struct and functions for the _Game of Islands_.\n\nThe state struct contains the fields `game_state`, `player1_state` and\n`player2_state` for implementing a state machine in the _Game of Islands_.\n\n##### Based on the book [Functional Web Development](https://pragprog.com/titles/lhelph/functional-web-development-with-elixir-otp-and-phoenix/) by Lance Halvorsen.","ref":"Islands.State.html"},{"type":"function","title":"Islands.State.check/2","doc":"Decides whether to permit the `state`/`event` combination. Also decides\nwhether to transition to a new state. Returns `{:ok, new_state}` if the\ncombination is permissible. Returns `:error` if it is not.","ref":"Islands.State.html#check/2"},{"type":"type","title":"Islands.State.event/0","doc":"State machine event","ref":"Islands.State.html#t:event/0"},{"type":"function","title":"Islands.State.fetch/2","doc":"Callback implementation for  Access.fetch/2 .","ref":"Islands.State.html#fetch/2"},{"type":"type","title":"Islands.State.game_state/0","doc":"Game state","ref":"Islands.State.html#t:game_state/0"},{"type":"function","title":"Islands.State.get_and_update/3","doc":"Callback implementation for  Access.get_and_update/3 .","ref":"Islands.State.html#get_and_update/3"},{"type":"function","title":"Islands.State.new/0","doc":"Creates a new state struct.","ref":"Islands.State.html#new/0"},{"type":"function","title":"Examples - Islands.State.new/0","doc":"iex> Islands.State.new()\n    %Islands.State{\n      game_state: :initialized,\n      player1_state: :islands_not_set,\n      player2_state: :islands_not_set\n    }","ref":"Islands.State.html#new/0-examples"},{"type":"type","title":"Islands.State.player_state/0","doc":"Player state","ref":"Islands.State.html#t:player_state/0"},{"type":"function","title":"Islands.State.pop/2","doc":"Callback implementation for  Access.pop/2 .","ref":"Islands.State.html#pop/2"},{"type":"type","title":"Islands.State.t/0","doc":"A state struct for the Game of Islands","ref":"Islands.State.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}